#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define rg register
#define ill inline
#define mp make_pair
#define db double
#define eps 1e-9
#define rep(i, a, b) for (int i = a; i <= b; i++)

using namespace std;

const int maxn = 2e5 + 7;
const int inf = 1e9;
const double pi = acos(-1);

inline ll read()
{
    ll x = 0, f = 1;
    char ch = getchar();
    while (ch < '0' || ch > '9')
    {
        if (ch == '-')
            f = -1;
        ch = getchar();
    }
    while (ch >= '0' && ch <= '9')
    {
        x = x * 10 + ch - '0';
        ch = getchar();
    }
    return x * f;
}

int n, m;
struct node
{
    double dis;
    int id;
    friend bool operator<(node a, node b)
    {
        return a.dis > b.dis;
    }
    node(){};
    node(double _x, int _y)
    {
        dis = _x;
        id = _y;
    }
};

priority_queue<node> pq;
double dis[maxn];
int fir[maxn], nxt[maxn * 2], to[maxn * 2];
double val[maxn * 2];
int X[maxn], Y[maxn];
int cnt = 0;
int vis[maxn];
int pre[maxn];

ill double cal(int p, int q)
{
    return sqrt(double((X[p] - X[q]) * (X[p] - X[q]) + (Y[p] - Y[q]) * (Y[p] - Y[q])));
}

ill void add_e(int x, int y)
{
    db edg = cal(x, y);
    //cout<<x<<" "<<y<<" "<<edg<<"\n";
    nxt[++cnt] = fir[x];
    fir[x] = cnt;
    to[cnt] = y;
    val[cnt] = edg;
    nxt[++cnt] = fir[y];
    fir[y] = cnt;
    to[cnt] = x;
    val[cnt] = edg;
}

vector<int> vec, vec1;

int main()
{
    freopen("usa.txt", "r", stdin);
    n = read();
    m = read();
    int fe, p, q;
    for (rg int i = 0; i < n; i++)
    {
        fe = read();
        //cout<<tmp<<endl;
        X[fe] = read();
        Y[fe] = read();
    }
    for (rg int i = 1; i <= m; i++)
    {
        p = read();
        q = read();
        add_e(p, q);
    }
    // cout<<222<<endl;
    for (rg int i = 0; i < n; i++)
        dis[i] = inf;
    freopen("usa1.txt", "r", stdin);
    //cout<<222<<endl;
    int s, t;
    int tt = read();
    db tmp;
    while (tt--)
    {
        //  cout<<tt<<endl;
        s = read();
        t = read(); //cout<<s<<" "<<t<<endl;
        for (rg int i = 0; i < (int)vec.size(); i++)
            dis[vec[i]] = inf;
        dis[s] = 0.0;
        for (rg int i = 0; i < (int)vec1.size(); i++)
            vis[vec1[i]] = 0;
        //cout<<dis[t]<<"\n";
        vec.clear();
        vec1.clear();
        vec.pb(s);
        while (!pq.empty())
            pq.pop();
        pq.push(node(0, s));
        //pre[s]=0;
        while (!pq.empty())
        {
            node k = pq.top();
            pq.pop();
            double dx = k.dis;
            int x = k.id;
            //cout<<x<<endl;
            if (x == t)
                break;
            if (vis[x])
                continue;
            vis[x] = 1;
            vec1.pb(x);
            for (rg int i = fir[x]; i; i = nxt[i])
            {
                //if(vis[to[i]])continue;
                //cout<<dx+val[i]<<"\n";
                tmp = dx + val[i] + cal(to[i], t) - cal(x, t);
                if (dis[to[i]] > tmp)
                {
                    pre[to[i]] = x;
                    dis[to[i]] = tmp;
                    if (!vis[to[i]])
                        pq.push(node(dis[to[i]], to[i])), vec.pb(to[i]);
                }
            }
        }
        cout << dis[t] + cal(s, t) << "\n";
    }
    return 0;
}
